import { toArray } from 'rxjs/operators';

import { ShowVersionCommand } from '../src/commands/show.version.command';
import { Options } from '../src/options';
import { CommandFactory } from './../src/commands/factory';

describe('show.version', () => {

    it('should produce a version string', () => {

        const fct = new CommandFactory();
        const opt: Options = {
            'command': ShowVersionCommand.COMMAND,
            'commandType': ShowVersionCommand.TYPE,
            'allArgs': []
        };

        return fct.create(opt).process().pipe(toArray()).toPromise()
            .then(res => {
                expect(res).toBeDefined();
                expect(res.length).toBe(1);
                expect(res[0]).toContain('version');
            });
    });
});
