import { join, parse } from 'path';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';

import { rxStats } from '../../src/utils/rx.walk';

export function getAssetBaseDir(): string {
    return join(__dirname, './../../../assets');
}

export function fileExists(aPath: string): Observable<boolean> {
    return rxStats(aPath).pipe(
        map(stats => stats && stats.isFile())
    );
}

export function dirExists(aPath: string): Observable<boolean> {
    return rxStats(aPath).pipe(
        map(stats => stats && stats.isDirectory())
    );
}

export function findFile(aFileName: string, aArray: string[]): string | undefined {
    return aArray.find(name => parse(name).base === aFileName);
}
