// regular expression to detect uuid.v4 strings
const TENANT_BASED_URL_REGEXP = /^(http[s]?:\/\/(?:[^:\/]+)(?::\d+)?)(?:\/api)?(\/(?:[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-4[0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}\/)?)(?:.*)$/;

/** Decodes the hub info from the base URL. This assumes
* that the application is served from a location in WCH.
*/
function _getDeliveryURL(aBaseURL) {
    // match
    const result = TENANT_BASED_URL_REGEXP.exec(aBaseURL);
    // construct the base URL
    return `${result[1]}/api${result[2]}`;
}

function _addLinksJsonp(aDocument, aLinks) {
    // base element
    const head = aDocument.head;
    const url = _getDeliveryURL(aDocument.URL);

    const _setAttribute = (link, key, value) => link.setAttribute(key, value);

    const _addLink = url => {
        const link = aDocument.createElement('link');
        _setAttribute(link, 'rel', 'prefetch');
        _setAttribute(link, 'href', url);
        _setAttribute(link, 'as', 'script');
        // append
        head.appendChild(link);
    };

    // iterate over the links
    const len = aLinks.length;
    for (let i = 0; i < len; ++i) {
        _addLink(`${url}${aLinks[i]}`);
    }
}

_addLinksJsonp(document, C);
