'use strict';

const fs = require('fs');
const path = require('path');

const regex = /\$\{BUILD_DATE\}/g;

function _rewriteBuildDate(aPath) {
    fs.readFile(aPath, 'utf-8', (errRead, data) => {
        if (errRead) {
            console.error(errRead);
        } else {
            // replace the token
            const date = new Date();
            data = data.replace(regex, date.toISOString());
            // write back
            fs.writeFile(aPath, data, 'utf-8', errWrite => {
                if (errWrite) {
                    console.error(errWrite);
                }
            });
        }
    });
}

_rewriteBuildDate(path.join(__dirname, 'dist', 'src', 'utils', 'build.date.js'));