"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var operators_1 = require("rxjs/operators");
var ast_utils_1 = require("../src/utils/ast.utils");
var test_utils_1 = require("./utils/test.utils");
describe('ast.utils', function () {
    it('should be able to insert a module', function () {
        // path
        var appModuleFile = path_1.join(test_utils_1.getAssetBaseDir(), 'test', 'empty-project', 'src', 'app', 'app.module.ts');
        // parse
        return ast_utils_1.rxReadTypescriptFile(appModuleFile).pipe(operators_1.map(function (file) { return ast_utils_1.importModule('MyModule', '@my/module', file); }), operators_1.map(function (res) {
            // check
            expect(res.source.includes('import { MyModule } from \'@my/module\'')).toBeTruthy();
        }))
            .toPromise();
    });
    it('should be able to parse a typescript file', function () {
        // path
        var appModuleFile = path_1.join(test_utils_1.getAssetBaseDir(), 'test', 'empty-project', 'src', 'app', 'app.module.ts');
        // parse
        return ast_utils_1.rxReadTypescriptFile(appModuleFile).pipe(operators_1.map(function (res) {
            expect(res.path).toEqual(appModuleFile);
            expect(res.ast).toBeDefined();
            expect(res.source).toBeDefined();
        }))
            .toPromise();
    });
});
