"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright IBM Corp. 2017 */
var os_1 = require("os");
var path_1 = require("path");
var rxjs_1 = require("rxjs");
var uuid_1 = require("uuid");
var create_components_command_1 = require("../src/commands/create.components.command");
var create_layouts_command_1 = require("../src/commands/create.layouts.command");
var rx_delete_1 = require("../src/utils/rx.delete");
var rx_copy_1 = require("./../src/utils/rx.copy");
var test_utils_1 = require("./utils/test.utils");
describe('create.layouts', function () {
    it('should be able to create the oslo layouts', function () {
        var dir = os_1.tmpdir();
        var name = uuid_1.v4();
        var dstBase = path_1.join(dir, name);
        var assetBase = test_utils_1.getAssetBaseDir();
        var dstData = path_1.join(dir, name, 'data');
        var dstSrc = dstBase;
        var srcSrc = path_1.join(assetBase, 'test', 'empty-project');
        var srcData = path_1.join(assetBase, 'test', 'oslo');
        var rxDelete = rx_delete_1.rxDeleteDir(dstBase);
        // copy the data
        var rxData = rxjs_1.merge(rx_copy_1.rxCopyDir(srcSrc, dstSrc), rx_copy_1.rxCopyDir(srcData, dstData));
        // create layouts on the result
        var layoutOpt = {
            command: create_layouts_command_1.CreateLayoutsCommand.COMMAND,
            commandType: create_layouts_command_1.CreateLayoutsCommand.TYPE,
            data: dstData,
            verbose: false,
            override: true,
            allArgs: []
        };
        var layoutCmd = new create_layouts_command_1.CreateLayoutsCommand(layoutOpt);
        var rxLayoutCmd = layoutCmd.process();
        // create layouts on the result
        var cmpOpt = {
            command: create_components_command_1.CreateComponentsCommand.COMMAND,
            commandType: create_components_command_1.CreateComponentsCommand.TYPE,
            data: dstData,
            src: path_1.join(dstSrc, 'src', 'app'),
            verbose: false,
            override: true,
            skipRegistration: true,
            scss: true,
            allArgs: []
        };
        var cmpCmd = new create_components_command_1.CreateComponentsCommand(cmpOpt);
        var rxCmpCmd = cmpCmd.process();
        var rxTotal = rxjs_1.concat(rxDelete, rxData, rxLayoutCmd, rxCmpCmd, rxDelete);
        return rxTotal.toPromise();
    });
});
