"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright IBM Corp. 2017 */
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var rx_utils_1 = require("../src/utils/rx.utils");
describe('rx', function () {
    it('should forkjoin empty', function () {
        var rxDeps = [];
        var bInvoked = false;
        return rx_utils_1.rxForkJoin(rxDeps).pipe(operators_1.map(function (res) {
            expect(res).toHaveLength(0);
            bInvoked = true;
        }))
            .toPromise()
            .then(function () { return expect(bInvoked).toBeTruthy(); });
    });
    it('should subscribe twice', function () {
        var rxSeq = rxjs_1.Observable.create(function (o) {
            o.next(Math.random());
            o.complete();
        });
        var rxTotal = rxjs_1.concat(rxSeq, rxSeq);
        return rxTotal.pipe(operators_1.distinct(), operators_1.toArray(), operators_1.tap(function (arr) { return expect(arr.length).toBe(2); }))
            .toPromise();
    });
});
