"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright IBM Corp. 2018 */
var os_1 = require("os");
var path_1 = require("path");
var operators_1 = require("rxjs/operators");
var uuid_1 = require("uuid");
var rx_delete_1 = require("../src/utils/rx.delete");
var rx_download_1 = require("../src/utils/rx.download");
var rx_zip_1 = require("../src/utils/rx.zip");
describe('rx.unzip', function () {
    it('should download zipball', function () {
        var dir = os_1.tmpdir();
        var name = uuid_1.v4();
        var dstName = path_1.join(dir, name + '.zip');
        var ob = rx_download_1.rxDownloadFile('https://api.github.com/repos/ibm-wch/wch-site-application/zipball', dstName).pipe(operators_1.first(), operators_1.tap(function (s) { return expect(s).toBe(dstName); }), operators_1.switchMap(rx_delete_1.rxDeleteFile));
        return ob.toPromise();
    });
    it('should download and uncompress', function () {
        var dir = os_1.tmpdir();
        var name = uuid_1.v4();
        var dstDir = path_1.join(dir, name);
        var rxDelete = rx_delete_1.rxDeleteDir(dstDir);
        var ob = rx_zip_1.rxUnzipFromUrl('https://github.com/ibm-wch/wch-site-application/archive/master.zip', dstDir).pipe(operators_1.toArray(), operators_1.tap(function (files) { return expect(files.length).toBeGreaterThan(0); }), operators_1.mergeMapTo(rxDelete));
        return ob.toPromise();
    });
    it('should download', function () {
        var dir = os_1.tmpdir();
        var name = uuid_1.v4();
        var dstName = path_1.join(dir, name + '.zip');
        var ob = rx_download_1.rxDownloadFile('https://github.com/ibm-wch/wch-site-application/archive/master.zip', dstName).pipe(operators_1.first(), operators_1.tap(function (s) { return expect(s).toBe(dstName); }), operators_1.switchMap(rx_delete_1.rxDeleteFile));
        return ob.toPromise();
    });
});
