"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var layout_utils_1 = require("../src/utils/layout.utils");
var type_dependencies_1 = require("../src/utils/type.dependencies");
var wchtools_1 = require("../src/utils/wchtools");
var test_utils_1 = require("./utils/test.utils");
describe('type.dependencies', function () {
    function _toNames(aTypes) {
        return aTypes.map(function (type) { return type.name; });
    }
    it('should detect type dependencies', function () {
        var assetBase = test_utils_1.getAssetBaseDir();
        var srcData = path_1.join(assetBase, 'test', 'ryan-group');
        // load wchtools
        var rxTools = wchtools_1.readWchTools(srcData).pipe(operators_1.shareReplay());
        // map
        var rxDeps = rxTools.pipe(operators_1.map(type_dependencies_1.getPageTypeDependencies));
        var rxLayouts = rxjs_1.combineLatest(rxDeps, rxTools).pipe(operators_1.map(function (_a) {
            var deps = _a[0], tools = _a[1];
            return deps.map(function (dep) { return layout_utils_1.getLayoutsForTypes(dep, tools); });
        }));
        return rxLayouts.toPromise();
    });
});
