"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var operators_1 = require("rxjs/operators");
var rx_walk_1 = require("../../src/utils/rx.walk");
function getAssetBaseDir() {
    return path_1.join(__dirname, './../../../assets');
}
exports.getAssetBaseDir = getAssetBaseDir;
function fileExists(aPath) {
    return rx_walk_1.rxStats(aPath).pipe(operators_1.map(function (stats) { return stats && stats.isFile(); }));
}
exports.fileExists = fileExists;
function dirExists(aPath) {
    return rx_walk_1.rxStats(aPath).pipe(operators_1.map(function (stats) { return stats && stats.isDirectory(); }));
}
exports.dirExists = dirExists;
function findFile(aFileName, aArray) {
    return aArray.find(function (name) { return path_1.parse(name).base === aFileName; });
}
exports.findFile = findFile;
