import { Observable, Subject } from 'rxjs';
import { Options } from './../options';
import { WchTools, WchToolsOptions } from './../utils/wchtools';
import { Command } from './command';
import { AngularCliConfiguration } from '../utils/angular/angular';
export declare abstract class AbstractCommand implements Command {
    private abstractOptions;
    private resourceRoot;
    private _logger;
    constructor(abstractOptions: Options);
    private _packageDir;
    private _dataDir;
    private _appDir;
    private _packageConfig;
    private _bPackageConfig;
    private _appName;
    private _contextRoot;
    private _apiBase;
    private _deliveryBase;
    private _appAssetDir;
    private _wchToolsOptions;
    private _wchTools;
    private _angularJson;
    protected validateWchToolsOptions(aOpt: WchToolsOptions): boolean;
    protected getWchTools(): Observable<WchTools>;
    protected getWchToolsOptions(): Observable<WchToolsOptions>;
    protected getAngularCliConfig(): Observable<AngularCliConfiguration>;
    protected getContextRoot(aAppName?: string): string;
    protected getAppAssetDir(aAppName?: string): string;
    protected getApiBase(): Observable<string>;
    protected getDeliveryBase(): Observable<string>;
    protected getPackageConfig(): any;
    protected getAppName(): string;
    protected getAppDir(): string;
    protected getConfigValue(aKey: string): string | undefined;
    protected getDataDir(): string;
    protected getPackageDir(): string;
    protected getCommandName(): string;
    printHelp(): void;
    protected getLogger(): Subject<string>;
    protected getOptions(): Options;
    protected getFileName(aIdentifier: string): string;
    protected rxMkdirp(aPath: string): Observable<string>;
    abstract process(): Observable<string>;
}
