"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var constants_1 = require("./../constants");
var abstract_command_1 = require("./abstract.command");
var create_webappmanifest_command_1 = require("./create.webappmanifest.command");
/* Copyright IBM Corp. 2017 */
var FAVICON_REGEXP = /<link\s+[^>]*rel\s*=\s*\"icon\"[^>]*>[\s|\r|\n]+/g;
var HEAD_REGEXP = /<\/head>/g;
function _getWebAppType(aWchTools) {
    return aWchTools.types[create_webappmanifest_command_1.UUID_MANIFEST_TYPE];
}
function _addFavicon(aHtml, aType, aWchTools, aLogger) {
    // the icons
    var icons = [];
    // check the image profile
    var elements = aType.elements;
    var imageElement = elements.find(function (el) { return (el.elementType === 'image') && (el.key === 'icon'); });
    if (imageElement) {
        // get the profile ID
        var profileId = imageElement.imageProfileId;
        if (profileId) {
            // get the profile
            var profile = aWchTools.imageProfiles[profileId];
            if (profile) {
                // iterate over the dimensions
                profile.dimensions.forEach(function (d) {
                    // construct the icon text
                    icons.push("<!-- " + d.key + " -->\n<link rel=\"icon\" type=\"image/png\" href=\"...\" sizes=\"" + d.width + "x" + d.height + "\">");
                });
            }
            else {
                console.error("Unable to locate the image profile for ID [" + profileId + "].");
            }
        }
        else {
            console.error("No profile ID for image element.");
        }
    }
    else {
        console.error("Unable to locate an image element for type [" + aType.id + "].");
    }
    // remove the existing favicons
    var html = aHtml;
    if (icons.length > 0) {
        // replace the old icon
        html = html.replace(FAVICON_REGEXP, '');
        // add the new icons
        var iconsMarkup = icons.join('\n');
        html = html.replace(HEAD_REGEXP, iconsMarkup + "\n</head>");
    }
    // the rewritten markup
    return html;
}
/**
 * Generates layout and layout mappings
 *
 * add prefetch --data DATA_FOLDER --src SRC_FOLDER
 */
var AddFaviconCommand = /** @class */ (function (_super) {
    __extends(AddFaviconCommand, _super);
    function AddFaviconCommand(options) {
        var _this = _super.call(this, options) || this;
        _this.options = options;
        return _this;
    }
    AddFaviconCommand.prototype.process = function () {
        // options
        var opts = this.options;
        return rxjs_1.empty();
    };
    AddFaviconCommand.TYPE = 'favicon';
    AddFaviconCommand.COMMAND = constants_1.CMD_ADD;
    return AddFaviconCommand;
}(abstract_command_1.AbstractCommand));
exports.AddFaviconCommand = AddFaviconCommand;
