import { Observable, Subject } from 'rxjs';
import { Options } from './../options';
import { WchToolsOptions } from './../utils/wchtools';
import { AbstractCommand } from './abstract.command';
import { Command } from './command';
declare function _createNgCli(aSrcDir: string, aName: string, aLogger: Subject<string>): Observable<string>;
declare function _createAppConfig(aSourceDir: string, aDataDir: string, aOverride: boolean): Observable<string>;
declare function _createWchtoolsOptions(aDataDir: string, aConfig: WchToolsOptions, aLogger: Subject<string>): Observable<string>;
declare function _updateProjectTypings(aTypingsFile: string, aLogger: Subject<string>): Observable<string>;
declare function _copyResources(aSrcDir: string, aName: string, aOpts: WchToolsOptions, aLogger: Subject<string>): Observable<string>;
/**
 * Generates angular components based on type and layout mapping definitions
 *
 * create project --src SOURCE_CODE_FOLDER --name NAME
 */
export declare class CreateProjectCommand extends AbstractCommand implements Command {
    private options;
    static readonly TYPE: string;
    static readonly COMMAND: string;
    constructor(options: Options);
    printHelp(): void;
    process(): Observable<string>;
}
export { _createNgCli as createNgCli, _copyResources as createProjectCopyResources, _createWchtoolsOptions as createProjectCreateWchtoolsOptions, _updateProjectTypings as createProjectUpdateTypings, _createAppConfig as createProjectCreateAppConfig };
