"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright IBM Corp. 2017 */
var rxjs_1 = require("rxjs");
var constants_1 = require("./../constants");
var version_1 = require("./../utils/version");
var abstract_command_1 = require("./abstract.command");
var ShowVersionCommand = /** @class */ (function (_super) {
    __extends(ShowVersionCommand, _super);
    function ShowVersionCommand(options) {
        var _this = _super.call(this, options) || this;
        _this.options = options;
        return _this;
    }
    ShowVersionCommand.prototype.printHelp = function () {
        // log the command line
        console.log(ShowVersionCommand.COMMAND, ShowVersionCommand.TYPE);
    };
    ShowVersionCommand.prototype.process = function () {
        // defer
        return rxjs_1.defer(function () {
            // get the version string
            var version = "version: " + version_1.VERSION.version + ", build: " + version_1.VERSION.build;
            return rxjs_1.of(version);
        });
    };
    ShowVersionCommand.TYPE = 'version';
    ShowVersionCommand.COMMAND = constants_1.CMD_SHOW;
    return ShowVersionCommand;
}(abstract_command_1.AbstractCommand));
exports.ShowVersionCommand = ShowVersionCommand;
