import { Observable } from 'rxjs';
import { FileDescriptor } from './rx.walk';
export declare const KEY_WCHTOOLS_DEPENDENCIES = "wchtools-dependencies";
export declare const DEPENDENCIES = "dependencies";
export declare function rxResolveEdges(aPackageFile: string): Observable<string[]>;
/**
 * Returns the 'wchtools-dependencies' in topological order
 *
 * @param aPackageFile  the package file
 * @return the dependencies in topological order
 */
export declare function rxResolveDependencies(aPackageFile: string, aReversedOrder?: boolean): Observable<string>;
/**
 * Provides a listing of all files to copie copied, in overlayed order. The relative
 * paths of the result are the relevant target paths
 *
 * @param aPackageFile  the package file
 * @return observable of the copied files
 */
export declare function rxAggregateDependencies(aPackageFile: string): Observable<FileDescriptor>;
/**
 * Provides a listing of all files to copie copied, in overlayed order. The relative
 * paths of the result are the relevant target paths
 *
 * @param aPackageFile  the package file
 * @param aDstDir target directory
 * @return observable of the copied files
 */
export declare function rxCopyDependencies(aPackageFile: string, aDstDir: string): Observable<string>;
