import { Observable, Subject, UnaryFunction } from 'rxjs';
import { Options } from './../options';
import { TypeClass, TypeRegistry } from './type.reg';
export interface ComponentClass {
    folder: string;
    typeDef: TypeClass;
    abstractComponentClass: string;
    typeComponentClass: string;
    typeInterfaceClass: string;
    abstractComponentFile: string;
    typeComponentFile: string;
    typeInterfaceFile: string;
    typeTemplateFile: string;
    typeStyleFile: string;
    abstractComponentRef: string;
    typeComponentRef: string;
    typeInterfaceRef: string;
    typeSelector: string;
}
export declare class ComponentRegistry {
    private aBaseFolders;
    private aOptions;
    private aMkdirp;
    private aTypeRegistry;
    private aLogger;
    private componentRegistry;
    constructor(aBaseFolders: Observable<string[]>, aOptions: Options, aMkdirp: UnaryFunction<string, Observable<string>>, aTypeRegistry: TypeRegistry, aLogger: Subject<string>);
    registerType(aType: any): boolean;
    findTypeClass(aType: any): Observable<TypeClass>;
    findComponentClass(aType: any): Observable<ComponentClass>;
}
