"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * some magic number
 */
var GOLDEN_RATIO_64 = 0xfd258f8f3210c68;
/** initial value for the hash code */
var HASH_SEED_64 = 0x47da98c72c46f4a6;
/**
 * Returns an initial value for the hash code
 *
 * @return the initial value
 */
function _longHash() {
    return HASH_SEED_64;
}
exports.longHash = _longHash;
function _longCombine(oldHash, data) {
    // tslint:disable-next-line:no-bitwise
    return oldHash ^ (data + GOLDEN_RATIO_64 + (oldHash << 6) + (oldHash >> 2));
}
function _hashString(oldHash, s) {
    var newHash = oldHash;
    var len = s.length;
    while (len-- > 0) {
        newHash = _longCombine(newHash, s.charCodeAt(len));
    }
    return newHash;
}
exports.hashString = _hashString;
// some character sets
var _START = '$_';
var _DIGITS = '0123456789';
var _LOWERCASE = 'abcdefghijklmnopqrstuvwxyz';
var _UPPERCASE = _LOWERCASE.toUpperCase();
// valid first letters
var _FIRST_LETTERS = _START + _LOWERCASE + _UPPERCASE;
var _NEXT_LETTERS = _FIRST_LETTERS + _DIGITS;
var _FIRST_LETTERS_LENGTH = _FIRST_LETTERS.length;
var _NEXT_LETTERS_LENGTH = _NEXT_LETTERS.length;
// shortcut to math functions
var _abs = Math.abs;
var _floor = Math.floor;
/**
 * Converts a hash number into a javascript identifier
 *
 * @param aHash     the hash number
 * @return a valid javascript identifier
 */
function _hashToIdentifier(aHash) {
    // make sure the number is positive
    var num = _abs(_floor(aHash));
    var res = [_FIRST_LETTERS[num % _FIRST_LETTERS_LENGTH]];
    num = _floor(num / _FIRST_LETTERS_LENGTH);
    // next
    while (num > 0) {
        res.push(_NEXT_LETTERS[num % _NEXT_LETTERS_LENGTH]);
        num = _floor(num / _NEXT_LETTERS_LENGTH);
    }
    // ok
    return res.join('');
}
exports.hashToIdentifier = _hashToIdentifier;
