"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var rx_walk_1 = require("./rx.walk");
/**
 * Locates the first directory that contains a certain file
 *
 * @param aSources  the list of source files to check
 * @param aRelPath  the relative path
 *
 * @return the observable
 */
function rxFindDir(aSources, aRelPath, aMkdirp) {
    // map each source to a check
    return aSources.pipe(operators_1.mergeMap(function (sources) { return rxjs_1.forkJoin(sources.map(function (dir) { return rx_walk_1.rxStats(path_1.join(dir, aRelPath)).pipe(operators_1.mapTo(dir), operators_1.catchError(function (err) { return rxjs_1.of(null); })); })).pipe(operators_1.map(function (result) { return result.filter(Boolean); }), operators_1.map(function (result) { return (result.length > 0) ? result[0] : sources[0]; })); }), operators_1.mergeMap(aMkdirp));
}
exports.rxFindDir = rxFindDir;
