/// <reference types="node" />
import { Stats, PathLike } from 'graceful-fs';
import { Observable, UnaryFunction } from 'rxjs';
export interface FileDescriptor {
    root: string;
    relPath: string;
    absPath: string;
    stats: Stats;
}
export declare function rxGetFileDescriptor(aFile: string, aRoot: string): Observable<FileDescriptor>;
declare function _walkFiles(aRoot: string): Observable<FileDescriptor>;
declare function _writeFileIfChanged(aPath: string, aData: any): Observable<string>;
declare function _writeFile(aPath: string, aData: any): Observable<string>;
declare function _readFile(aPath: string): Observable<string>;
declare const _rxDeleteFile: (aPath: string) => Observable<string>;
declare const _rxMkdirp: (aPath: string) => Observable<string>;
declare const _rxStats: UnaryFunction<PathLike, Observable<Stats>>;
declare const _rxCopyFile: (aSrc: string, aDst: string, aOverride?: boolean | undefined) => Observable<string>;
export declare function rxCopyFileStream(aSrc: string, aDst: string): Observable<string>;
declare const _rxReaddir: (arg1: PathLike) => Observable<string[]>;
declare function _validateNotExists(aDir: string): Observable<string>;
declare function _rxTempDir(): Observable<string>;
export { _walkFiles as walkFiles, _walkFiles as rxWalkFiles, _writeFile as writeFile, _writeFileIfChanged as writeFileIfChanged, _readFile as readFile, _rxMkdirp as rxMkdirp, _rxStats as rxStats, _rxReaddir as rxReaddir, _rxCopyFile as rxCopyFile, _rxDeleteFile as rxDeleteFile, _rxTempDir as rxTempDir, _validateNotExists as rxValidateNotExists };
