"use strict";
exports.__esModule = true;
var add_base_command_1 = require("./add.base.command");
var add_copyright_1 = require("./add.copyright");
var add_esi_polyfill_command_1 = require("./add.esi.polyfill.command");
var add_favicon_command_1 = require("./add.favicon.command");
var add_library_command_1 = require("./add.library.command");
var add_preload_command_1 = require("./add.preload.command");
var add_webappmanifest_command_1 = require("./add.webappmanifest.command");
var application_pull_command_1 = require("./application.pull.command");
var application_purge_command_1 = require("./application.purge.command");
var application_push_command_1 = require("./application.push.command");
var build_development_command_1 = require("./build.development.command");
var build_production_command_1 = require("./build.production.command");
var canonicalize_assets_command_1 = require("./canonicalize.assets.command");
var cleanup_assets_command_1 = require("./cleanup.assets.command");
var compress_assets_command_1 = require("./compress.assets.command");
var copy_build_command_1 = require("./copy.build.command");
var copy_content_command_1 = require("./copy.content.command");
var copy_data_command_1 = require("./copy.data.command");
var create_asset_command_1 = require("./create.asset.command");
var create_components_command_1 = require("./create.components.command");
var create_from_archive_command_1 = require("./create.from.archive.command");
var create_images_command_1 = require("./create.images.command");
var create_layout_command_1 = require("./create.layout.command");
var create_layouts_command_1 = require("./create.layouts.command");
var create_mappings_command_1 = require("./create.mappings.command");
var create_page_type_command_1 = require("./create.page.type.command");
var create_project_command_1 = require("./create.project.command");
var create_site_command_1 = require("./create.site.command");
var create_webappmanifest_command_1 = require("./create.webappmanifest.command");
var empty_1 = require("./empty");
var normalize_json_command_1 = require("./normalize.json.command");
var register_layoutcomponents_command_1 = require("./register.layoutcomponents.command");
var run_wchtools_command_1 = require("./run.wchtools.command");
var show_graph_command_1 = require("./show.graph.command");
var show_types_command_1 = require("./show.types.command");
var show_url_command_1 = require("./show.url.command");
var show_version_command_1 = require("./show.version.command");
var store_credentials_command_1 = require("./store.credentials.command");
function _register(aCommand, aType, aConstructor, aMap) {
    // types
    var byType = aMap[aCommand] || (aMap[aCommand] = {});
    byType[aType] = aConstructor;
}
var CommandFactory = /** @class */ (function () {
    function CommandFactory() {
        this.commands = {};
        var cmd = this.commands;
        _register(empty_1.EmptyCommand.COMMAND, empty_1.EmptyCommand.TYPE, empty_1.EmptyCommand, cmd);
        _register(create_layout_command_1.CreateLayoutCommand.COMMAND, create_layout_command_1.CreateLayoutCommand.TYPE, create_layout_command_1.CreateLayoutCommand, cmd);
        _register(cleanup_assets_command_1.CleanupAssetsCommand.COMMAND, cleanup_assets_command_1.CleanupAssetsCommand.TYPE, cleanup_assets_command_1.CleanupAssetsCommand, cmd);
        _register(create_mappings_command_1.CreateMappingsCommand.COMMAND, create_mappings_command_1.CreateMappingsCommand.TYPE, create_mappings_command_1.CreateMappingsCommand, cmd);
        _register(add_copyright_1.AddCopyrightCommand.COMMAND, add_copyright_1.AddCopyrightCommand.TYPE, add_copyright_1.AddCopyrightCommand, cmd);
        _register(create_components_command_1.CreateComponentsCommand.COMMAND, create_components_command_1.CreateComponentsCommand.TYPE, create_components_command_1.CreateComponentsCommand, cmd);
        _register(create_layouts_command_1.CreateLayoutsCommand.COMMAND, create_layouts_command_1.CreateLayoutsCommand.TYPE, create_layouts_command_1.CreateLayoutsCommand, cmd);
        _register(add_preload_command_1.AddPreloadCommand.COMMAND, add_preload_command_1.AddPreloadCommand.TYPE, add_preload_command_1.AddPreloadCommand, cmd);
        _register(create_project_command_1.CreateProjectCommand.COMMAND, create_project_command_1.CreateProjectCommand.TYPE, create_project_command_1.CreateProjectCommand, cmd);
        _register(application_push_command_1.ApplicationPushCommand.COMMAND, application_push_command_1.ApplicationPushCommand.TYPE, application_push_command_1.ApplicationPushCommand, cmd);
        _register(application_pull_command_1.ApplicationPullCommand.COMMAND, application_pull_command_1.ApplicationPullCommand.TYPE, application_pull_command_1.ApplicationPullCommand, cmd);
        _register(create_site_command_1.CreateSiteCommand.COMMAND, create_site_command_1.CreateSiteCommand.TYPE, create_site_command_1.CreateSiteCommand, cmd);
        _register(show_types_command_1.ShowTypesCommand.COMMAND, show_types_command_1.ShowTypesCommand.TYPE, show_types_command_1.ShowTypesCommand, cmd);
        _register(show_url_command_1.ShowUrlCommand.COMMAND, show_url_command_1.ShowUrlCommand.TYPE, show_url_command_1.ShowUrlCommand, cmd);
        _register(store_credentials_command_1.StoreCredentialsCommand.COMMAND, store_credentials_command_1.StoreCredentialsCommand.TYPE, store_credentials_command_1.StoreCredentialsCommand, cmd);
        _register(add_base_command_1.AddBaseCommand.COMMAND, add_base_command_1.AddBaseCommand.TYPE, add_base_command_1.AddBaseCommand, cmd);
        _register(create_page_type_command_1.CreatePageTypeCommand.COMMAND, create_page_type_command_1.CreatePageTypeCommand.TYPE, create_page_type_command_1.CreatePageTypeCommand, cmd);
        _register(create_asset_command_1.CreateAssetCommand.COMMAND, create_asset_command_1.CreateAssetCommand.TYPE, create_asset_command_1.CreateAssetCommand, cmd);
        _register(show_graph_command_1.ShowGraphCommand.COMMAND, show_graph_command_1.ShowGraphCommand.TYPE, show_graph_command_1.ShowGraphCommand, cmd);
        _register(create_webappmanifest_command_1.CreateWebAppManifestCommand.COMMAND, create_webappmanifest_command_1.CreateWebAppManifestCommand.TYPE, create_webappmanifest_command_1.CreateWebAppManifestCommand, cmd);
        _register(add_webappmanifest_command_1.AddWebAppManifestCommand.COMMAND, add_webappmanifest_command_1.AddWebAppManifestCommand.TYPE, add_webappmanifest_command_1.AddWebAppManifestCommand, cmd);
        _register(create_images_command_1.CreateImagesCommand.COMMAND, create_images_command_1.CreateImagesCommand.TYPE, create_images_command_1.CreateImagesCommand, cmd);
        _register(add_favicon_command_1.AddFaviconCommand.COMMAND, add_favicon_command_1.AddFaviconCommand.TYPE, add_favicon_command_1.AddFaviconCommand, cmd);
        _register(build_production_command_1.BuildProductionCommand.COMMAND, build_production_command_1.BuildProductionCommand.TYPE, build_production_command_1.BuildProductionCommand, cmd);
        _register(build_development_command_1.BuildDevelopmentCommand.COMMAND, build_development_command_1.BuildDevelopmentCommand.TYPE, build_development_command_1.BuildDevelopmentCommand, cmd);
        _register(run_wchtools_command_1.RunWchToolsCommand.COMMAND, run_wchtools_command_1.RunWchToolsCommand.TYPE, run_wchtools_command_1.RunWchToolsCommand, cmd);
        _register(normalize_json_command_1.NormalizeJsonCommand.COMMAND, normalize_json_command_1.NormalizeJsonCommand.TYPE, normalize_json_command_1.NormalizeJsonCommand, cmd);
        _register(add_esi_polyfill_command_1.AddEsiPolyfillCommand.COMMAND, add_esi_polyfill_command_1.AddEsiPolyfillCommand.TYPE, add_esi_polyfill_command_1.AddEsiPolyfillCommand, cmd);
        _register(show_version_command_1.ShowVersionCommand.COMMAND, show_version_command_1.ShowVersionCommand.TYPE, show_version_command_1.ShowVersionCommand, cmd);
        _register(copy_build_command_1.CopyBuildCommand.COMMAND, copy_build_command_1.CopyBuildCommand.TYPE, copy_build_command_1.CopyBuildCommand, cmd);
        _register(application_purge_command_1.ApplicationPurgeCommand.COMMAND, application_purge_command_1.ApplicationPurgeCommand.TYPE, application_purge_command_1.ApplicationPurgeCommand, cmd);
        _register(register_layoutcomponents_command_1.RegisterLayoutComponentsCommand.COMMAND, register_layoutcomponents_command_1.RegisterLayoutComponentsCommand.TYPE, register_layoutcomponents_command_1.RegisterLayoutComponentsCommand, cmd);
        _register(compress_assets_command_1.CompressAssetsCommand.COMMAND, compress_assets_command_1.CompressAssetsCommand.TYPE, compress_assets_command_1.CompressAssetsCommand, cmd);
        _register(create_from_archive_command_1.CreateFromArchiveCommand.COMMAND, create_from_archive_command_1.CreateFromArchiveCommand.TYPE, create_from_archive_command_1.CreateFromArchiveCommand, cmd);
        _register(copy_data_command_1.CopyDataCommand.COMMAND, copy_data_command_1.CopyDataCommand.TYPE, copy_data_command_1.CopyDataCommand, cmd);
        _register(canonicalize_assets_command_1.CanonicalizeAssetsCommand.COMMAND, canonicalize_assets_command_1.CanonicalizeAssetsCommand.TYPE, canonicalize_assets_command_1.CanonicalizeAssetsCommand, cmd);
        _register(copy_content_command_1.CopyContentCommand.COMMAND, copy_content_command_1.CopyContentCommand.TYPE, copy_content_command_1.CopyContentCommand, cmd);
        _register(add_library_command_1.AddLibraryCommand.COMMAND, add_library_command_1.AddLibraryCommand.TYPE, add_library_command_1.AddLibraryCommand, cmd);
    }
    CommandFactory.prototype.create = function (options) {
        // get the type
        var cmd = options.command || 'help';
        var type = options.commandType || 'help';
        // lookup
        var byType = this.commands[cmd] || {};
        var creator = byType[type] || empty_1.EmptyCommand;
        // construct the command
        return new creator(options);
    };
    return CommandFactory;
}());
exports.CommandFactory = CommandFactory;
