"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
/* Copyright IBM Corp. 2017 */
var mime_1 = require("mime");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var constants_1 = require("./../constants");
var json_1 = require("./../utils/json");
var rx_walk_1 = require("./../utils/rx.walk");
var abstract_command_1 = require("./abstract.command");
var help_1 = require("./help");
function _normalizeSingleJson(aJson) {
    return json_1.canonicalizeJSON(aJson);
}
function _normalizeSingleJsonFile(aFileName, aLogger) {
    // read file
    return rxjs_1.of(aFileName).pipe(operators_1.tap(function (name) { return aLogger.next("Reading [" + name + "]."); }), operators_1.mergeMap(function (name) { return rx_walk_1.readFile(aFileName); }), operators_1.mergeMap(function (data) {
        var normalized = JSON.stringify(_normalizeSingleJson(JSON.parse(data)), undefined, 2);
        return (data !== normalized) ? rx_walk_1.writeFile(aFileName, normalized).pipe(operators_1.tap(function (name) { return aLogger.next("Written [" + name + "]."); })) : rxjs_1.empty();
    }));
}
function _normalizeAll(aDir, aLogger) {
    // walk all JSON files
    return rx_walk_1.walkFiles(aDir).pipe(operators_1.filter(function (file) { return mime_1.getType(file.absPath) === 'application/json'; }), operators_1.mergeMap(function (file) { return _normalizeSingleJsonFile(file.absPath, aLogger); }));
}
var NormalizeJsonCommand = /** @class */ (function (_super) {
    __extends(NormalizeJsonCommand, _super);
    function NormalizeJsonCommand() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NormalizeJsonCommand.prototype.printHelp = function () {
        // log the command line
        console.log(NormalizeJsonCommand.COMMAND, NormalizeJsonCommand.TYPE, "[--" + constants_1.OPTION_DATA + " <DATA>]", "[--" + constants_1.OPTION_VERBOSE + "]");
        // log the parameters
        console.log("--" + constants_1.OPTION_DATA, ':', constants_1.OPTION_DATA);
        console.log("--" + constants_1.OPTION_VERBOSE, ':', help_1.HELP_VERBOSE);
    };
    NormalizeJsonCommand.prototype.process = function () {
        // start with the data directory
        var dataDir = this.getDataDir();
        // logging
        var logger = this.getLogger();
        // process
        return _normalizeAll(dataDir, logger);
    };
    NormalizeJsonCommand.TYPE = 'json';
    NormalizeJsonCommand.COMMAND = constants_1.CMD_NORMALIZE;
    return NormalizeJsonCommand;
}(abstract_command_1.AbstractCommand));
exports.NormalizeJsonCommand = NormalizeJsonCommand;
