/**
 * This file was automatically generated by json-schema-to-typescript.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
 * and run json-schema-to-typescript to regenerate this file.
 */

/**
 * File format version
 */
export type FileVersion = number;

export interface AngularCliConfiguration {
  $schema?: string;
  version: FileVersion;
  cli?: CliOptions;
  schematics?: SchematicOptions;
  /**
   * Path where new projects will be created.
   */
  newProjectRoot?: string;
  /**
   * Default project name used in commands.
   */
  defaultProject?: string;
  projects?: {
    [k: string]: Project;
  };
}
export interface CliOptions {
  /**
   * The default schematics collection to use.
   */
  defaultCollection?: string;
  /**
   * Specify which package manager tool to use.
   */
  packageManager?: "npm" | "cnpm" | "yarn";
  /**
   * Control CLI specific console warnings
   */
  warnings?: {
    /**
     * Show a warning when the global version is newer than the local one.
     */
    versionMismatch?: boolean;
    /**
     * Show a warning when the TypeScript version is incompatible.
     */
    typescriptMismatch?: boolean;
    [k: string]: any;
  };
}
export interface SchematicOptions {
  "@schematics/angular:component": {
    /**
     * Specifies if the style will be in the ts file.
     */
    inlineStyle?: boolean;
    /**
     * Specifies if the template will be in the ts file.
     */
    inlineTemplate?: boolean;
    /**
     * Specifies the view encapsulation strategy.
     */
    viewEncapsulation?: "Emulated" | "Native" | "None";
    /**
     * Specifies the change detection strategy.
     */
    changeDetection?: "Default" | "OnPush";
    /**
     * The prefix to apply to generated selectors.
     */
    prefix?: string;
    /**
     * The file extension to be used for style files.
     */
    styleext?: string;
    /**
     * Specifies if a spec file is generated.
     */
    spec?: boolean;
    /**
     * Flag to indicate if a dir is created.
     */
    flat?: boolean;
    /**
     * Flag to skip the module import.
     */
    skipImport?: boolean;
    /**
     * The selector to use for the component.
     */
    selector?: string;
    /**
     * Allows specification of the declaring module.
     */
    module?: string;
    /**
     * Specifies if declaring module exports the component.
     */
    export?: boolean;
    [k: string]: any;
  };
  "@schematics/angular:directive": {
    /**
     * The prefix to apply to generated selectors.
     */
    prefix?: string;
    /**
     * Specifies if a spec file is generated.
     */
    spec?: boolean;
    /**
     * Flag to skip the module import.
     */
    skipImport?: boolean;
    /**
     * The selector to use for the directive.
     */
    selector?: string;
    /**
     * Flag to indicate if a dir is created.
     */
    flat?: boolean;
    /**
     * Allows specification of the declaring module.
     */
    module?: string;
    /**
     * Specifies if declaring module exports the directive.
     */
    export?: boolean;
    [k: string]: any;
  };
  "@schematics/angular:module": {
    /**
     * Generates a routing module.
     */
    routing?: boolean;
    /**
     * The scope for the generated routing.
     */
    routingScope?: "Child" | "Root";
    /**
     * Specifies if a spec file is generated.
     */
    spec?: boolean;
    /**
     * Flag to indicate if a dir is created.
     */
    flat?: boolean;
    /**
     * Flag to control whether the CommonModule is imported.
     */
    commonModule?: boolean;
    /**
     * Allows specification of the declaring module.
     */
    module?: string;
    [k: string]: any;
  };
  "@schematics/angular:service": {
    /**
     * Flag to indicate if a dir is created.
     */
    flat?: boolean;
    /**
     * Specifies if a spec file is generated.
     */
    spec?: boolean;
    [k: string]: any;
  };
  "@schematics/angular:pipe": {
    /**
     * Flag to indicate if a dir is created.
     */
    flat?: boolean;
    /**
     * Specifies if a spec file is generated.
     */
    spec?: boolean;
    /**
     * Allows for skipping the module import.
     */
    skipImport?: boolean;
    /**
     * Allows specification of the declaring module.
     */
    module?: string;
    /**
     * Specifies if declaring module exports the pipe.
     */
    export?: boolean;
    [k: string]: any;
  };
  "@schematics/angular:class": {
    /**
     * Specifies if a spec file is generated.
     */
    spec?: boolean;
    [k: string]: any;
  };
  [k: string]: {
    [k: string]: any;
  };
}
/**
 * This interface was referenced by `undefined`'s JSON-Schema definition
 * via the `patternProperty` "^[a-zA-Z][.0-9a-zA-Z]*(-[.0-9a-zA-Z]*)*$".
 */
export interface Project {
  cli?: CliOptions;
  schematics?: SchematicOptions;
  /**
   * The prefix to apply to generated selectors.
   */
  prefix?: string;
  /**
   * Root of the project files.
   */
  root: string;
  /**
   * The root of the source files, assets and index.html file structure.
   */
  sourceRoot?: string;
  /**
   * Project type.
   */
  projectType: "application" | "library";
  architect?: {
    [k: string]:
      | {
          /**
           * The builder used for this package.
           */
          builder: string;
          options?: {
            [k: string]: any;
          };
          /**
           * A map of alternative target options.
           */
          configurations?: {
            [k: string]: {
              [k: string]: any;
            };
          };
          [k: string]: any;
        }
      | {
          builder?: {
            [k: string]: any;
          };
          /**
           * App Shell target options for Build Facade.
           */
          options?: {
            /**
             * Target to build.
             */
            browserTarget?: string;
            /**
             * Server target to use for rendering the app shell.
             */
            serverTarget?: string;
            /**
             * Script that exports the Server AppModule to render. This should be the main JavaScript outputted by the server target. By default we will resolve the outputPath of the serverTarget and find a bundle named 'main' in it (whether or not there's a hash tag).
             */
            appModuleBundle?: string;
            /**
             * The route to render.
             */
            route?: string;
            /**
             * The input path for the index.html file. By default uses the output index.html of the browser target.
             */
            inputIndexPath?: string;
            /**
             * The output path of the index.html file. By default will overwrite the input file.
             */
            outputIndexPath?: string;
          };
          configurations?: {
            /**
             * App Shell target options for Build Facade.
             */
            [k: string]: {
              /**
               * Target to build.
               */
              browserTarget?: string;
              /**
               * Server target to use for rendering the app shell.
               */
              serverTarget?: string;
              /**
               * Script that exports the Server AppModule to render. This should be the main JavaScript outputted by the server target. By default we will resolve the outputPath of the serverTarget and find a bundle named 'main' in it (whether or not there's a hash tag).
               */
              appModuleBundle?: string;
              /**
               * The route to render.
               */
              route?: string;
              /**
               * The input path for the index.html file. By default uses the output index.html of the browser target.
               */
              inputIndexPath?: string;
              /**
               * The output path of the index.html file. By default will overwrite the input file.
               */
              outputIndexPath?: string;
            };
          };
          [k: string]: any;
        }
      | {
          builder?: {
            [k: string]: any;
          };
          options?: WebpackBrowserSchemaForBuildFacade;
          configurations?: {
            [k: string]: WebpackBrowserSchemaForBuildFacade;
          };
          [k: string]: any;
        }
      | {
          builder?: {
            [k: string]: any;
          };
          /**
           * Dev Server target options for Build Facade.
           */
          options?: {
            /**
             * Target to serve.
             */
            browserTarget?: string;
            /**
             * Port to listen on.
             */
            port?: number;
            /**
             * Host to listen on.
             */
            host?: string;
            /**
             * Proxy configuration file.
             */
            proxyConfig?: string;
            /**
             * Serve using HTTPS.
             */
            ssl?: boolean;
            /**
             * SSL key to use for serving HTTPS.
             */
            sslKey?: string;
            /**
             * SSL certificate to use for serving HTTPS.
             */
            sslCert?: string;
            /**
             * Opens the url in default browser.
             */
            open?: boolean;
            /**
             * Whether to reload the page on change, using live-reload.
             */
            liveReload?: boolean;
            /**
             * Specify the URL that the browser client will use.
             */
            publicHost?: string;
            /**
             * The pathname where the app will be served.
             */
            servePath?: string;
            /**
             * Don't verify connected clients are part of allowed hosts.
             */
            disableHostCheck?: boolean;
            /**
             * Enable hot module replacement.
             */
            hmr?: boolean;
            /**
             * Rebuild on change.
             */
            watch?: boolean;
            /**
             * Show a warning when the --hmr option is enabled.
             */
            hmrWarning?: boolean;
            /**
             * Show a warning when deploy-url/base-href use unsupported serve path values.
             */
            servePathDefaultWarning?: boolean;
            /**
             * Defines the optimization level of the build.
             */
            optimization?: boolean;
            /**
             * Build using Ahead of Time compilation.
             */
            aot?: boolean;
            /**
             * Output sourcemaps.
             */
            sourceMap?: boolean;
            /**
             * Output in-file eval sourcemaps.
             */
            evalSourceMap?: boolean;
            /**
             * Use a separate bundle containing only vendor libraries.
             */
            vendorChunk?: boolean;
            /**
             * Use a separate bundle containing code used across multiple bundles.
             */
            commonChunk?: boolean;
            /**
             * Base url for the application being built.
             */
            baseHref?: string;
            /**
             * URL where files will be deployed.
             */
            deployUrl?: string;
            /**
             * Adds more details to output logging.
             */
            verbose?: boolean;
            /**
             * Log progress to the console while building.
             */
            progress?: boolean;
          };
          configurations?: {
            /**
             * Dev Server target options for Build Facade.
             */
            [k: string]: {
              /**
               * Target to serve.
               */
              browserTarget?: string;
              /**
               * Port to listen on.
               */
              port?: number;
              /**
               * Host to listen on.
               */
              host?: string;
              /**
               * Proxy configuration file.
               */
              proxyConfig?: string;
              /**
               * Serve using HTTPS.
               */
              ssl?: boolean;
              /**
               * SSL key to use for serving HTTPS.
               */
              sslKey?: string;
              /**
               * SSL certificate to use for serving HTTPS.
               */
              sslCert?: string;
              /**
               * Opens the url in default browser.
               */
              open?: boolean;
              /**
               * Whether to reload the page on change, using live-reload.
               */
              liveReload?: boolean;
              /**
               * Specify the URL that the browser client will use.
               */
              publicHost?: string;
              /**
               * The pathname where the app will be served.
               */
              servePath?: string;
              /**
               * Don't verify connected clients are part of allowed hosts.
               */
              disableHostCheck?: boolean;
              /**
               * Enable hot module replacement.
               */
              hmr?: boolean;
              /**
               * Rebuild on change.
               */
              watch?: boolean;
              /**
               * Show a warning when the --hmr option is enabled.
               */
              hmrWarning?: boolean;
              /**
               * Show a warning when deploy-url/base-href use unsupported serve path values.
               */
              servePathDefaultWarning?: boolean;
              /**
               * Defines the optimization level of the build.
               */
              optimization?: boolean;
              /**
               * Build using Ahead of Time compilation.
               */
              aot?: boolean;
              /**
               * Output sourcemaps.
               */
              sourceMap?: boolean;
              /**
               * Output in-file eval sourcemaps.
               */
              evalSourceMap?: boolean;
              /**
               * Use a separate bundle containing only vendor libraries.
               */
              vendorChunk?: boolean;
              /**
               * Use a separate bundle containing code used across multiple bundles.
               */
              commonChunk?: boolean;
              /**
               * Base url for the application being built.
               */
              baseHref?: string;
              /**
               * URL where files will be deployed.
               */
              deployUrl?: string;
              /**
               * Adds more details to output logging.
               */
              verbose?: boolean;
              /**
               * Log progress to the console while building.
               */
              progress?: boolean;
            };
          };
          [k: string]: any;
        }
      | {
          builder?: {
            [k: string]: any;
          };
          /**
           * Extract i18n target options for Build Facade.
           */
          options?: {
            /**
             * Target to extract from.
             */
            browserTarget?: string;
            /**
             * Output format for the generated file.
             */
            i18nFormat?: "xmb" | "xlf" | "xlif" | "xliff" | "xlf2" | "xliff2";
            /**
             * Specifies the source language of the application.
             */
            i18nLocale?: string;
            /**
             * Path where output will be placed.
             */
            outputPath?: string;
            /**
             * Name of the file to output.
             */
            outFile?: string;
          };
          configurations?: {
            /**
             * Extract i18n target options for Build Facade.
             */
            [k: string]: {
              /**
               * Target to extract from.
               */
              browserTarget?: string;
              /**
               * Output format for the generated file.
               */
              i18nFormat?: "xmb" | "xlf" | "xlif" | "xliff" | "xlf2" | "xliff2";
              /**
               * Specifies the source language of the application.
               */
              i18nLocale?: string;
              /**
               * Path where output will be placed.
               */
              outputPath?: string;
              /**
               * Name of the file to output.
               */
              outFile?: string;
            };
          };
          [k: string]: any;
        }
      | {
          builder?: {
            [k: string]: any;
          };
          /**
           * Karma target options for Build Facade.
           */
          options?: {
            /**
             * The name of the main entry-point file.
             */
            main?: string;
            /**
             * The name of the TypeScript configuration file.
             */
            tsConfig?: string;
            /**
             * The name of the Karma configuration file.
             */
            karmaConfig?: string;
            /**
             * The name of the polyfills file.
             */
            polyfills?: string;
            /**
             * List of static application assets.
             */
            assets?: (
              | {
                  /**
                   * The pattern to match.
                   */
                  glob: string;
                  /**
                   * The input path dir in which to apply 'glob'. Defaults to the project root.
                   */
                  input: string;
                  /**
                   * Absolute path within the output.
                   */
                  output: string;
                }
              | string)[];
            /**
             * Global scripts to be included in the build.
             */
            scripts?: (
              | {
                  /**
                   * The file to include.
                   */
                  input: string;
                  /**
                   * The bundle name for this extra entry point.
                   */
                  bundleName?: string;
                  /**
                   * If the bundle will be lazy loaded.
                   */
                  lazy?: boolean;
                }
              | string)[];
            /**
             * Global styles to be included in the build.
             */
            styles?: (
              | {
                  /**
                   * The file to include.
                   */
                  input: string;
                  /**
                   * The bundle name for this extra entry point.
                   */
                  bundleName?: string;
                  /**
                   * If the bundle will be lazy loaded.
                   */
                  lazy?: boolean;
                }
              | string)[];
            /**
             * Options to pass to style preprocessors
             */
            stylePreprocessorOptions?: {
              /**
               * Paths to include. Paths will be resolved to project root.
               */
              includePaths?: string[];
            };
            /**
             * Defines the build environment.
             */
            environment?: string;
            /**
             * Output sourcemaps.
             */
            sourceMap?: boolean;
            /**
             * Log progress to the console while building.
             */
            progress?: boolean;
            /**
             * Run build when files change.
             */
            watch?: boolean;
            /**
             * Enable and define the file watching poll time period in milliseconds.
             */
            poll?: number;
            /**
             * Do not use the real path when resolving modules.
             */
            preserveSymlinks?: boolean;
            /**
             * Override which browsers tests are run against.
             */
            browsers?: string;
            /**
             * Output a code coverage report.
             */
            codeCoverage?: boolean;
            /**
             * Globs to exclude from code coverage.
             */
            codeCoverageExclude?: string[];
            /**
             * Replace files with other files in the build.
             */
            fileReplacements?: (
              | {
                  src: string;
                  replaceWith: string;
                }
              | {
                  replace: string;
                  with: string;
                })[];
          };
          configurations?: {
            /**
             * Karma target options for Build Facade.
             */
            [k: string]: {
              /**
               * The name of the main entry-point file.
               */
              main?: string;
              /**
               * The name of the TypeScript configuration file.
               */
              tsConfig?: string;
              /**
               * The name of the Karma configuration file.
               */
              karmaConfig?: string;
              /**
               * The name of the polyfills file.
               */
              polyfills?: string;
              /**
               * List of static application assets.
               */
              assets?: (
                | {
                    /**
                     * The pattern to match.
                     */
                    glob: string;
                    /**
                     * The input path dir in which to apply 'glob'. Defaults to the project root.
                     */
                    input: string;
                    /**
                     * Absolute path within the output.
                     */
                    output: string;
                  }
                | string)[];
              /**
               * Global scripts to be included in the build.
               */
              scripts?: (
                | {
                    /**
                     * The file to include.
                     */
                    input: string;
                    /**
                     * The bundle name for this extra entry point.
                     */
                    bundleName?: string;
                    /**
                     * If the bundle will be lazy loaded.
                     */
                    lazy?: boolean;
                  }
                | string)[];
              /**
               * Global styles to be included in the build.
               */
              styles?: (
                | {
                    /**
                     * The file to include.
                     */
                    input: string;
                    /**
                     * The bundle name for this extra entry point.
                     */
                    bundleName?: string;
                    /**
                     * If the bundle will be lazy loaded.
                     */
                    lazy?: boolean;
                  }
                | string)[];
              /**
               * Options to pass to style preprocessors
               */
              stylePreprocessorOptions?: {
                /**
                 * Paths to include. Paths will be resolved to project root.
                 */
                includePaths?: string[];
              };
              /**
               * Defines the build environment.
               */
              environment?: string;
              /**
               * Output sourcemaps.
               */
              sourceMap?: boolean;
              /**
               * Log progress to the console while building.
               */
              progress?: boolean;
              /**
               * Run build when files change.
               */
              watch?: boolean;
              /**
               * Enable and define the file watching poll time period in milliseconds.
               */
              poll?: number;
              /**
               * Do not use the real path when resolving modules.
               */
              preserveSymlinks?: boolean;
              /**
               * Override which browsers tests are run against.
               */
              browsers?: string;
              /**
               * Output a code coverage report.
               */
              codeCoverage?: boolean;
              /**
               * Globs to exclude from code coverage.
               */
              codeCoverageExclude?: string[];
              /**
               * Replace files with other files in the build.
               */
              fileReplacements?: (
                | {
                    src: string;
                    replaceWith: string;
                  }
                | {
                    replace: string;
                    with: string;
                  })[];
            };
          };
          [k: string]: any;
        }
      | {
          builder?: {
            [k: string]: any;
          };
          /**
           * Protractor target options for Build Facade.
           */
          options?: {
            /**
             * The name of the Protractor configuration file.
             */
            protractorConfig?: string;
            /**
             * Dev server target to run tests against.
             */
            devServerTarget?: string;
            /**
             * Override specs in the protractor config.
             */
            specs?: string[];
            /**
             * Override suite in the protractor config.
             */
            suite?: string;
            /**
             * Start Protractor's Element Explorer for debugging.
             */
            elementExplorer?: boolean;
            /**
             * Try to update webdriver.
             */
            webdriverUpdate?: boolean;
            /**
             * Compile and Serve the app.
             */
            serve?: boolean;
            /**
             * The port to use to serve the application.
             */
            port?: number;
            /**
             * Host to listen on.
             */
            host?: string;
            /**
             * Base URL for protractor to connect to.
             */
            baseUrl?: string;
          };
          configurations?: {
            /**
             * Protractor target options for Build Facade.
             */
            [k: string]: {
              /**
               * The name of the Protractor configuration file.
               */
              protractorConfig?: string;
              /**
               * Dev server target to run tests against.
               */
              devServerTarget?: string;
              /**
               * Override specs in the protractor config.
               */
              specs?: string[];
              /**
               * Override suite in the protractor config.
               */
              suite?: string;
              /**
               * Start Protractor's Element Explorer for debugging.
               */
              elementExplorer?: boolean;
              /**
               * Try to update webdriver.
               */
              webdriverUpdate?: boolean;
              /**
               * Compile and Serve the app.
               */
              serve?: boolean;
              /**
               * The port to use to serve the application.
               */
              port?: number;
              /**
               * Host to listen on.
               */
              host?: string;
              /**
               * Base URL for protractor to connect to.
               */
              baseUrl?: string;
            };
          };
          [k: string]: any;
        }
      | {
          builder?: {
            [k: string]: any;
          };
          options?: AngularWebpackArchitectBuilderSchema;
          configurations?: {
            [k: string]: AngularWebpackArchitectBuilderSchema;
          };
          [k: string]: any;
        }
      | {
          builder?: {
            [k: string]: any;
          };
          /**
           * TSlint target options for Build Facade.
           */
          options?: {
            /**
             * The name of the TSLint configuration file.
             */
            tslintConfig?: string;
            /**
             * The name of the TypeScript configuration file.
             */
            tsConfig?: string | string[];
            /**
             * Fixes linting errors (may overwrite linted files).
             */
            fix?: boolean;
            /**
             * Controls the type check for linting.
             */
            typeCheck?: boolean;
            /**
             * Succeeds even if there was linting errors.
             */
            force?: boolean;
            /**
             * Show output text.
             */
            silent?: boolean;
            /**
             * Output format (prose, json, stylish, verbose, pmd, msbuild, checkstyle, vso, fileslist).
             */
            format?: "prose" | "json" | "stylish" | "verbose" | "pmd" | "msbuild" | "checkstyle" | "vso" | "fileslist";
            /**
             * Files to exclude from linting.
             */
            exclude?: string[];
            /**
             * Files to include in linting.
             */
            files?: string[];
          };
          configurations?: {
            /**
             * TSlint target options for Build Facade.
             */
            [k: string]: {
              /**
               * The name of the TSLint configuration file.
               */
              tslintConfig?: string;
              /**
               * The name of the TypeScript configuration file.
               */
              tsConfig?: string | string[];
              /**
               * Fixes linting errors (may overwrite linted files).
               */
              fix?: boolean;
              /**
               * Controls the type check for linting.
               */
              typeCheck?: boolean;
              /**
               * Succeeds even if there was linting errors.
               */
              force?: boolean;
              /**
               * Show output text.
               */
              silent?: boolean;
              /**
               * Output format (prose, json, stylish, verbose, pmd, msbuild, checkstyle, vso, fileslist).
               */
              format?:
                | "prose"
                | "json"
                | "stylish"
                | "verbose"
                | "pmd"
                | "msbuild"
                | "checkstyle"
                | "vso"
                | "fileslist";
              /**
               * Files to exclude from linting.
               */
              exclude?: string[];
              /**
               * Files to include in linting.
               */
              files?: string[];
            };
          };
          [k: string]: any;
        };
  };
  /**
   * This interface was referenced by `Project`'s JSON-Schema definition
   * via the `patternProperty` "^[a-z]{1,3}-.*".
   */
  [k: string]: any;
}
/**
 * Browser target options
 */
export interface WebpackBrowserSchemaForBuildFacade {
  /**
   * List of static application assets.
   */
  assets?: (
    | {
        /**
         * The pattern to match.
         */
        glob: string;
        /**
         * The input path dir in which to apply 'glob'. Defaults to the project root.
         */
        input: string;
        /**
         * Absolute path within the output.
         */
        output: string;
      }
    | string)[];
  /**
   * The name of the main entry-point file.
   */
  main?: string;
  /**
   * The name of the polyfills file.
   */
  polyfills?: string;
  /**
   * The name of the TypeScript configuration file.
   */
  tsConfig?: string;
  /**
   * Global scripts to be included in the build.
   */
  scripts?: (
    | {
        /**
         * The file to include.
         */
        input: string;
        /**
         * The bundle name for this extra entry point.
         */
        bundleName?: string;
        /**
         * If the bundle will be lazy loaded.
         */
        lazy?: boolean;
      }
    | string)[];
  /**
   * Global styles to be included in the build.
   */
  styles?: (
    | {
        /**
         * The file to include.
         */
        input: string;
        /**
         * The bundle name for this extra entry point.
         */
        bundleName?: string;
        /**
         * If the bundle will be lazy loaded.
         */
        lazy?: boolean;
      }
    | string)[];
  /**
   * Options to pass to style preprocessors.
   */
  stylePreprocessorOptions?: {
    /**
     * Paths to include. Paths will be resolved to project root.
     */
    includePaths?: string[];
  };
  /**
   * Defines the optimization level of the build.
   */
  optimization?: boolean;
  /**
   * Replace files with other files in the build.
   */
  fileReplacements?: (
    | {
        src: string;
        replaceWith: string;
      }
    | {
        replace: string;
        with: string;
      })[];
  /**
   * Path where output will be placed.
   */
  outputPath?: string;
  /**
   * Build using Ahead of Time compilation.
   */
  aot?: boolean;
  /**
   * Output sourcemaps.
   */
  sourceMap?: boolean;
  /**
   * Output in-file eval sourcemaps.
   */
  evalSourceMap?: boolean;
  /**
   * Use a separate bundle containing only vendor libraries.
   */
  vendorChunk?: boolean;
  /**
   * Use a separate bundle containing code used across multiple bundles.
   */
  commonChunk?: boolean;
  /**
   * Base url for the application being built.
   */
  baseHref?: string;
  /**
   * URL where files will be deployed.
   */
  deployUrl?: string;
  /**
   * Adds more details to output logging.
   */
  verbose?: boolean;
  /**
   * Log progress to the console while building.
   */
  progress?: boolean;
  /**
   * Localization file to use for i18n.
   */
  i18nFile?: string;
  /**
   * Format of the localization file specified with --i18n-file.
   */
  i18nFormat?: string;
  /**
   * Locale to use for i18n.
   */
  i18nLocale?: string;
  /**
   * How to handle missing translations for i18n.
   */
  i18nMissingTranslation?: string;
  /**
   * Extract css from global styles onto css files instead of js ones.
   */
  extractCss?: boolean;
  /**
   * Run build when files change.
   */
  watch?: boolean;
  /**
   * Define the output filename cache-busting hashing mode.
   */
  outputHashing?: "none" | "all" | "media" | "bundles";
  /**
   * Enable and define the file watching poll time period in milliseconds.
   */
  poll?: number;
  /**
   * Delete the output path before building.
   */
  deleteOutputPath?: boolean;
  /**
   * Do not use the real path when resolving modules.
   */
  preserveSymlinks?: boolean;
  /**
   * Extract all licenses in a separate file, in the case of production builds only.
   */
  extractLicenses?: boolean;
  /**
   * Show circular dependency warnings on builds.
   */
  showCircularDependencies?: boolean;
  /**
   * Enables @angular-devkit/build-optimizer optimizations when using the 'aot' option.
   */
  buildOptimizer?: boolean;
  /**
   * Use file name for lazy loaded chunks.
   */
  namedChunks?: boolean;
  /**
   * Enables the use of subresource integrity validation.
   */
  subresourceIntegrity?: boolean;
  /**
   * Generates a service worker config for production builds.
   */
  serviceWorker?: boolean;
  /**
   * Flag to prevent building an app shell.
   */
  skipAppShell?: boolean;
  /**
   * The name of the index HTML file.
   */
  index?: string;
  /**
   * Generates a 'stats.json' file which can be analyzed using tools such as: #webpack-bundle-analyzer' or https: //webpack.github.io/analyse.
   */
  statsJson?: boolean;
  /**
   * Run the TypeScript type checker in a forked process.
   */
  forkTypeChecker?: boolean;
  /**
   * List of additional NgModule files that will be lazy loaded. Lazy router modules with be discovered automatically.
   */
  lazyModules?: string[];
  /**
   * Budget thresholds to ensure parts of your application stay within boundaries which you set.
   */
  budgets?: {
    /**
     * The type of budget.
     */
    type: "all" | "allScript" | "any" | "anyScript" | "bundle" | "initial";
    /**
     * The name of the bundle.
     */
    name?: string;
    /**
     * The baseline size for comparison.
     */
    baseline?: string;
    /**
     * The maximum threshold for warning relative to the baseline.
     */
    maximumWarning?: string;
    /**
     * The maximum threshold for error relative to the baseline.
     */
    maximumError?: string;
    /**
     * The minimum threshold for warning relative to the baseline.
     */
    minimumWarning?: string;
    /**
     * The minimum threshold for error relative to the baseline.
     */
    minimumError?: string;
    /**
     * The threshold for warning relative to the baseline (min & max).
     */
    warning?: string;
    /**
     * The threshold for error relative to the baseline (min & max).
     */
    error?: string;
  }[];
}
export interface AngularWebpackArchitectBuilderSchema {
  /**
   * The name of the main entry-point file.
   */
  main?: string;
  /**
   * The name of the TypeScript configuration file.
   */
  tsConfig?: string;
  /**
   * Options to pass to style preprocessors
   */
  stylePreprocessorOptions?: {
    /**
     * Paths to include. Paths will be resolved to project root.
     */
    includePaths?: string[];
  };
  /**
   * Defines the optimization level of the build.
   */
  optimization?: boolean;
  /**
   * Replace files with other files in the build.
   */
  fileReplacements?: (
    | {
        src: string;
        replaceWith: string;
      }
    | {
        replace: string;
        with: string;
      })[];
  /**
   * Path where output will be placed.
   */
  outputPath?: string;
  /**
   * Output sourcemaps.
   */
  sourceMap?: boolean;
  /**
   * Output in-file eval sourcemaps.
   */
  evalSourceMap?: boolean;
  /**
   * Use a separate bundle containing only vendor libraries.
   */
  vendorChunk?: boolean;
  /**
   * Use a separate bundle containing code used across multiple bundles.
   */
  commonChunk?: boolean;
  /**
   * Adds more details to output logging.
   */
  verbose?: boolean;
  /**
   * Log progress to the console while building.
   */
  progress?: boolean;
  /**
   * Localization file to use for i18n.
   */
  i18nFile?: string;
  /**
   * Format of the localization file specified with --i18n-file.
   */
  i18nFormat?: string;
  /**
   * Locale to use for i18n.
   */
  i18nLocale?: string;
  /**
   * How to handle missing translations for i18n.
   */
  i18nMissingTranslation?: string;
  /**
   * Define the output filename cache-busting hashing mode.
   */
  outputHashing?: "none" | "all" | "media" | "bundles";
  /**
   * delete-output-path
   */
  deleteOutputPath?: boolean;
  /**
   * Do not use the real path when resolving modules.
   */
  preserveSymlinks?: boolean;
  /**
   * Extract all licenses in a separate file, in the case of production builds only.
   */
  extractLicenses?: boolean;
  /**
   * Show circular dependency warnings on builds.
   */
  showCircularDependencies?: boolean;
  /**
   * Use file name for lazy loaded chunks.
   */
  namedChunks?: boolean;
  /**
   * Available on server platform only. Which external dependencies to bundle into the module. By default, all of node_modules will be kept as requires.
   */
  bundleDependencies?: "none" | "all";
  /**
   * Generates a 'stats.json' file which can be analyzed using tools such as: #webpack-bundle-analyzer' or https: //webpack.github.io/analyse.
   */
  statsJson?: boolean;
  /**
   * Run the TypeScript type checker in a forked process.
   */
  forkTypeChecker?: boolean;
  /**
   * List of additional NgModule files that will be lazy loaded. Lazy router modules with be discovered automatically.
   */
  lazyModules?: string[];
}
