"use strict";
exports.__esModule = true;
/* Copyright IBM Corp. 2017 */
var lodash_1 = require("lodash");
var layout_utils_1 = require("./layout.utils");
function _getDefaultLayoutFromMapping(aLayoutMapping, aTools) {
    // check if we have a default
    var defaultLayout = aLayoutMapping.defaultLayout;
    if (lodash_1.isString(defaultLayout.id)) {
        // get the layout
        var layout = aTools.layouts[defaultLayout.id];
        if (layout_utils_1.isValidLayout(layout)) {
            // return this one
            return layout;
        }
    }
    // iterate over the remaining layouts
    var layouts = aLayoutMapping.layouts;
    var result = layouts.filter(function (layout) { return lodash_1.isString(layout.id); }).map(function (layout) { return aTools.layouts[layout.id]; }).filter(layout_utils_1.isValidLayout);
    if (result && (result.length > 0)) {
        return result[0];
    }
    return undefined;
}
exports._getDefaultLayoutFromMapping = _getDefaultLayoutFromMapping;
function getDefaultLayout(aLayoutMapping, aTools) {
    // check the mappings
    var mappings = aLayoutMapping.mappings || [];
    var result = mappings.map(function (mapping) { return _getDefaultLayoutFromMapping(mapping, aTools); }).filter(Boolean);
    if (result && (result.length > 0)) {
        return result[0];
    }
    return undefined;
}
exports.getDefaultLayout = getDefaultLayout;
