"use strict";
exports.__esModule = true;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
function rxForkJoin(aObservables) {
    // check the array
    return (aObservables && (aObservables.length > 0)) ? rxjs_1.forkJoin.apply(void 0, aObservables) : rxjs_1.of([]);
}
exports.rxForkJoin = rxForkJoin;
function rxCacheSingle(aObservable) {
    // helper subject
    var subject = new rxjs_1.ReplaySubject(1);
    // status flag
    var bSubscribed = false;
    // create the subscriber
    return rxjs_1.Observable.create(function (aObserver) {
        // have we already subscribed?
        if (!bSubscribed) {
            bSubscribed = true;
            aObservable.pipe(operators_1.take(1)).subscribe(subject);
        }
        // ok
        subject.pipe(operators_1.take(1)).subscribe(aObserver);
    });
}
exports.rxCacheSingle = rxCacheSingle;
